#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_icon=SetupSource\icon.ico
#AutoIt3Wrapper_outfile=VistumblerInstaller5.9.exe
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstants.au3>

$defaultfoldername = "Vistumbler" 
$SetupFilesRoot = "SetupFiles" 
$VistumblerEXE = "Vistumbler.exe" 
$VistumblerAU3 = "Vistumbler.au3" 
$VistumblerSettings = "vistumbler_settings.ini" 
$VistumblerMacLabels = "mac_labels.ini"
$VistumblerManufacturers = "manufactures.ini"
$VistumblerLanguageEnglish = "English.ini"
$VistumblerLanguageSpanish = "Espaol.ini"
$VistumblerNewAPSound = "new_ap.wav" 
$VistumblerErrorSound = "error.wav" 
$VistumblerIcon = "icon.ico" 
$VistumblerShortcut = "Vistumbler.lnk" 

Dim $SetupFiles = "SetupFiles" 

DirCreate($SetupFiles)
FileInstall('SetupSource\blue.bmp', 'SetupFiles\blue.bmp')
FileInstall('SetupSource\icon.ico', 'SetupFiles\icon.ico')
FileInstall('SetupSource\Sounds\new_ap.wav', 'SetupFiles\new_ap.wav')
FileInstall('SetupSource\Sounds\error.wav', 'SetupFiles\error.wav')
FileInstall('SetupSource\Vistumbler.au3', 'SetupFiles\Vistumbler.au3')
FileInstall('SetupSource\Vistumbler.exe', 'SetupFiles\Vistumbler.exe')
FileInstall('SetupSource\Settings\vistumbler_settings.ini', 'SetupFiles\vistumbler_settings.ini')
FileInstall('SetupSource\Settings\mac_labels.ini', 'SetupFiles\mac_labels.ini')
FileInstall('SetupSource\Settings\manufactures.ini', 'SetupFiles\manufactures.ini')
FileInstall('SetupSource\Languages\English.ini', 'SetupFiles\English.ini')
FileInstall('SetupSource\Languages\Espaol.ini', 'SetupFiles\Espaol.ini')

$VistumblerInstaller = GUICreate("Vistumbler Setup", 583, 329, 193, 115)
$Pic1 = GUICtrlCreatePic("SetupFiles\blue.bmp", 8, 8, 164, 314, BitOR($SS_NOTIFY, $WS_GROUP))

$WelcomeChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$WelcomeEdit = GUICtrlCreateEdit("", 8, 8, 369, 265)
GUICtrlSetData(-1, "Welcome to the Vistumbler Installer. For updates, visit " & @CRLF & "http://techidiots.net/project-pages/vistumbler/" & @CRLF & @CRLF & 'Vistumbler is for personal use only. The user is reponsible if they use ' & @CRLF & 'this application in an improper way.' & @CRLF & @CRLF & 'Vistumbler is open source. All I ask is if you use my code, give ' & @CRLF & 'me credit in some way.' & @CRLF & @CRLF & 'Click next only if you agree with these terms')
$WelcomeNext = GUICtrlCreateButton("&Next", 192, 280, 81, 25, 0)
$WelcomeCancel = GUICtrlCreateButton("&Cancel", 100, 280, 81, 25, 0)
GUISetState(@SW_SHOW)

$SaveChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$SaveInstall = GUICtrlCreateButton("&Install", 192, 280, 81, 25, 0)
$SaveCancel = GUICtrlCreateButton("&Cancel", 100, 280, 81, 25, 0)
GUICtrlCreateGroup("Where would you like to install vistumbler?", 8, 16, 369, 81)
$SaveInstallDir = GUICtrlCreateInput(@ProgramFilesDir & "\" & $defaultfoldername, 20, 46, 289, 21)
$SaveBrowse = GUICtrlCreateButton("Browse", 315, 44, 49, 17, 0)
GUICtrlCreateGroup("Would you like to make icons?", 8, 112, 369, 105)
$SaveDesktopIcon = GUICtrlCreateCheckbox("Add icon on desktop", 24, 144, 337, 17)
$SaveStartMenuIcon = GUICtrlCreateCheckbox("Add icon in start menu", 24, 176, 137, 17)
GUICtrlSetState($SaveDesktopIcon, $GUI_CHECKED)
GUICtrlSetState($SaveStartMenuIcon, $GUI_CHECKED)
$SaveStartMenuFolder = GUICtrlCreateInput($defaultfoldername, 168, 176, 161, 21)
GUISetState(@SW_HIDE)

$ErrorChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$ErrorEdit = GUICtrlCreateEdit("", 8, 8, 369, 209)
GUICtrlSetData(-1, "An error has occured. Vistumbler was not installed properly")
$ErrorExit = GUICtrlCreateButton("E&xit", 150, 230, 81, 25, 0)
GUISetState(@SW_HIDE)

$DoneChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$DoneEdit = GUICtrlCreateEdit("", 8, 8, 369, 209)
GUICtrlSetData(-1, "Vistumbler has succesfully installed")
$DoneExit = GUICtrlCreateButton("E&xit", 150, 230, 81, 25, 0)
GUISetState(@SW_HIDE)

GUISwitch($VistumblerInstaller)

GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			_ExitProgram()
		Case $WelcomeCancel
			_ExitProgram()
		Case $SaveCancel
			_ExitProgram()
		Case $ErrorExit
			_ExitProgram()
		Case $DoneExit
			_ExitProgram()
		Case $WelcomeNext
			GUISetState(@SW_SHOW, $SaveChild)
			GUISetState(@SW_HIDE, $WelcomeChild)
		Case $SaveInstall
			$DestinationDir = GUICtrlRead($SaveInstallDir)
			$StartMenuFolder = GUICtrlRead($SaveStartMenuFolder)
			
			DirRemove($DestinationDir)
			DirCreate($DestinationDir)
			DirCreate($DestinationDir & '\Settings')
			DirCreate($DestinationDir & '\Sounds')
			DirCreate($DestinationDir & '\Languages')

			$1 = FileCopy($SetupFilesRoot & "\" & $VistumblerEXE, $DestinationDir, 1)
			$2 = FileCopy($SetupFilesRoot & "\" & $VistumblerAU3, $DestinationDir, 1)
			$3 = FileCopy($SetupFilesRoot & "\" & $VistumblerSettings, $DestinationDir & '\Settings', 1)
			$4 = FileCopy($SetupFilesRoot & "\" & $VistumblerMacLabels, $DestinationDir & '\Settings', 1)
			$5 = FileCopy($SetupFilesRoot & "\" & $VistumblerManufacturers, $DestinationDir & '\Settings', 1)
			$6 = FileCopy($SetupFilesRoot & "\" & $VistumblerNewAPSound, $DestinationDir & '\Sounds', 1)
			$7 = FileCopy($SetupFilesRoot & "\" & $VistumblerErrorSound, $DestinationDir & '\Sounds', 1)
			$8 = FileCopy($SetupFilesRoot & "\" & $VistumblerLanguageEnglish, $DestinationDir & '\Languages', 1)
			$9 = FileCopy($SetupFilesRoot & "\" & $VistumblerLanguageSpanish, $DestinationDir & '\Languages', 1)
			$10 = FileCopy($SetupFilesRoot & "\" & $VistumblerIcon, $DestinationDir, 1)
			$successful = BitAND($1, $2, $3, $4, $5, $6, $7, $8, $9, $10)
			If $successful = 1 Then
				If GUICtrlRead($SaveDesktopIcon) = 1 Then
					FileCreateShortcut($DestinationDir & '\' & $VistumblerEXE, @DesktopDir & '\' & $VistumblerShortcut)
				EndIf
				If GUICtrlRead($SaveStartMenuIcon) = 1 Then
					DirCreate(@ProgramsDir & '\' & $StartMenuFolder)
					FileCreateShortcut($DestinationDir & '\' & $VistumblerEXE, @ProgramsDir & '\' & $StartMenuFolder & '\' & $VistumblerShortcut)
				EndIf
				GUISetState(@SW_SHOW, $DoneChild)
				GUISetState(@SW_HIDE, $SaveChild)
			Else
				GUISetState(@SW_SHOW, $ErrorChild)
				GUISetState(@SW_HIDE, $SaveChild)
			EndIf
		Case $SaveBrowse
			_Browse()
	EndSwitch
WEnd

Func _ExitProgram()
	DirRemove($SetupFiles, 1)
	Exit
EndFunc   ;==>_ExitProgram

Func _Browse()
	$newinstallfolder = FileSelectFolder("Install Dir", @ProgramFilesDir, 7)
	If Not @error Then GUICtrlSetData($SaveInstallDir, $newinstallfolder)
EndFunc   ;==>_Browse